/*
 *	app.h
 *
 *	CHIP/8 - P/ECE CHIP-8 Interpreter
 *
 *	* Mon Mar 22 06:00:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#include <clip.h>

/****************************************************************************
 *	
 ****************************************************************************/

extern unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
extern SURFACE surface;				/* zVRAM̃T[tFCX */
extern RENDER render;				/* zVRAMւ̕` */

extern int now;					/* O[o^C} */
extern int joy;					/* pbh */

/****************************************************************************
 *	
 ****************************************************************************/

#define CONFIG_FNAME	"chip8.cfg"	/* ݒۑt@C */

typedef struct _CONFIG {
	/* 1/60[sec]s閽ߐB */
	int spd;
	/* P/ECẼpbh͂ɑΉACHIP-8̃L[ԍ(0`15) */
	unsigned char pad[8];		/* 0:/1:E/2:E/3:E/4:/5:/6:/7: */
	unsigned char trg[2];		/* 0:A/1:B */
} CONFIG;
#define SPD_MIN		  1		/* CPUXs[h (1/60[sec]̖ߎs) ݒ艺 */
#define SPD_MAX		999		/* CPUXs[h (1/60[sec]̖ߎs) ݒ */

/****************************************************************************
 *	
 ****************************************************************************/

typedef struct _DRIVER {
	CHIP8 chip8;
	CONFIG config;
} DRIVER;

/****************************************************************************
 *	
 ****************************************************************************/

/* main.c */
int file_sel(const FILEINFO* file_list, int file_count, int cursel, int* curtop);
void run(DRIVER* driver, const char* fname);
void update_key(DRIVER* driver);
void show_config(DRIVER* driver, int sel);
int do_config(DRIVER* driver);
int load_config(CONFIG* config);
int save_config(const CONFIG* config);

/* fram.c */
void update_screen(DRIVER* driver);

