/*
 *	main.c
 *
 *	CHIP/8 - P/ECE CHIP-8 Interpreter
 *
 *	* Mon Mar 22 06:00:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 *	* Mon Mar 29 04:50:00 JST 2004 Naoyuki Sawa
 *	- EXIT߂sꂽAbZ[W\ăvOꗗʂɖ߂悤ɂ܂B
 *	- s߂sꂽAbZ[W\ăvOꗗʂɖ߂悤ɂ܂B
 *	* Fri Apr 3 07:42:00 JST 2004 Naoyuki Sawa
 *	- ݒt@CoCi`eLXg`ɕύX܂B
 *	- SPDݒ̏lA99999ɕύX܂B
 *	- SPDݒ莞ɁA㉺{^ōł悤ɂ܂B
 */
#include "app.h"

//#define USE_MUSIC /* yCugꍇ́ÃV{`Ă */
#ifdef USE_MUSIC
#include "instdef.c"
#define music_play(data) do { music_stop(); PlayMusic((unsigned char*)(data)); } while(0)
#define music_stop() do { StopMusic(); sound_stop(music_wch); } while(0)
#else /*USE_MUSIC*/
#define music_play(data) ((void)0)
#define music_stop() ((void)0)
#endif /*USE_MUSIC*/

//#define V_SCREEN /* cʃ[hgꍇ́ÃV{`Ă */
#ifdef V_SCREEN
#undef DISP_X
#undef DISP_Y
#define DISP_X	 88
#define DISP_Y	128
#endif /*V_SCREEN*/

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
//#define QUICK_REPEAT
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
#define QUICK_REPEAT_DELAY	SEC(0.25)

/* XvCg`BKvɉăCN[hĂBsprite.h̕ҏWKvłB */
//#include "sprite.h"
//#define DEFINE_SPRITE
//#include "sprite.h"
//#undef  DEFINE_SPRITE

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		60			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER render;				/* zVRAMւ̕` */

int now;				/* O[o^C} */
int joy;				/* pbh */

//extern const unsigned char PAT[];
//extern const unsigned char BG[];
//TEXTURE pat;
//TEXTURE bg;

char cfg_buf[BLOCKSIZE];		/* RtBOt@C1sǂݍ/Ss쐬p */

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
void mainloop();

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	mainloop();

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(1/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef USE_MUSIC
	/* yCu܂B */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

/*{{AvP[VL̏*/
	//turbo(1); /* S48MHz[h */
	//turbo(7); /* 48MHz/1WAIT */
	srand(pceTimerGetCount());
	/* rbg}bvB */
	//texture_init(&pat, PAT);
	//texture_init(&bg, BG);
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
#endif /*USE_MUSIC*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
#define PAUSE_COLOR	0x130		/* PAUSEJ[(wip) */
//#define PAUSE_COLOR	0x203		/* PAUSEJ[(wip) */
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5 + 2)	/* PAUSEbZ[W̉ */
#define PAUSE_H		(10    + 2)	/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */

#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int pause, x, y;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

		/* PAUSEB */
		if(0/*joy & TRG_START*/) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
	now++;	/* O[o^C}XV */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT

#undef PAUSE_FONT
#undef PAUSE_COLOR
#undef PAUSE_STR
#undef PAUSE_W
#undef PAUSE_H
#undef PAUSE_X
#undef PAUSE_Y
}

/****************************************************************************
 *	mainloop
 ****************************************************************************/

static int
file_info_compare(const void* _a, const void* _b)
{
	FILEINFO* a = (FILEINFO*)_a;
	FILEINFO* b = (FILEINFO*)_b;
	return strcmp(a->filename, b->filename);
}

void
mainloop()
{
	static FILEINFO file_list[MAXDIR];	/* CHIP-8vOt@CXg */
	static int file_count;			/* file_list[]̗vf */
	//
	static DRIVER driver;
	//
	int retval, i, cursel, curtop;
	FILEINFO fi;

	/* ݒǂݍ݂܂B */
	memset(vbuff, 0, sizeof vbuff);
	render_string(&render, 0, 0, "ݒǂݍݒ...", 0, 3);
	schedule();
	//
	retval = load_config(&driver.config);
	if(retval != 0) {
		memset(vbuff, 0, sizeof vbuff);
		render_string(&render, 0, 0, "ݒǂݍݎs", 0, 3);
		for(i = 0; i < SEC(1.0); i++) { schedule(); if(joy & (TRG_A | TRG_B | TRG_SELECT)) break; }
	}

	/* t@CXg쐬܂B */
	file_count = 0;
	retval = pceFileFindOpen(&fi);
	if(retval != 0) DIE();
	while(file_count < MAXDIR) {
		retval = pceFileFindNext(&fi);
		if(!retval) break;
		memset(vbuff, 0, sizeof vbuff);
		render_string(&render, 0,  0, "CHIP-8۸ь...", 0, 3);
		render_string(&render, 0, 10, fi.filename,              0, 3);
		schedule();
		retval = chip8_test(fi.filename, 0); /* LCHIP-8vOt@C? */
		if(retval == 0) {
			file_list[file_count] = fi;
			file_count++;
		}
	}
	pceFileFindClose(&fi);
	if(!file_count) {
		memset(vbuff, 0, sizeof vbuff);
		render_string(&render, (DISP_X - 5 * 25) / 2, (DISP_Y - 10) / 2,
		//       0123456789012345678901234
			"CHIP-8۸т܂", 0, 3);
		for(;;) {
			schedule();
			if(joy & (TRG_A | TRG_B | TRG_SELECT)) break;
		}
		return;
	}

	/* t@CɃ\[gB */
	qsort(file_list, file_count, sizeof(FILEINFO), file_info_compare);

	cursel = 0;
	curtop = 0;

	turbo(7); /* 48MHz/1WAIT */
	for(;;) {
		/* t@CI܂B */
		cursel = file_sel(file_list, file_count, cursel, &curtop);
		if(cursel < 0) break;

		/* vOs܂B */
		run(&driver, file_list[cursel].filename);
	}
	turbo(0); /* 24MHz/2WAIT */

	/* ݒۑ܂B(turbo[hłsƗ܂!!v!!) */
	memset(vbuff, 0, sizeof vbuff);
	render_string(&render, 0, 0, "ݒۑ...", 0, 3);
	schedule();
	//
	retval = save_config(&driver.config);
	if(retval != 0) {
		memset(vbuff, 0, sizeof vbuff);
		render_string(&render, 0, 0, "ݒۑs", 0, 3);
		for(i = 0; i < SEC(1.0); i++) { schedule(); if(joy & (TRG_A | TRG_B | TRG_SELECT)) break; }
	}
}

/****************************************************************************
 *	file_sel
 ****************************************************************************/

#define MAX_DISP	13	/* Sɕ\łt@C */

int
file_sel(const FILEINFO* file_list, int file_count, int cursel, int* curtop)
{
	int result;
	int c, i, y, i_list;
	const FILEINFO* fi;

	pcePadSetTrigMode(PP_MODE_REPEAT); /* I[gs[gON */
	for(;;) {
		schedule();

		/* IH */
		if(joy & TRG_SELECT) {
			result = -1;
			break;
		}

		/* t@CIύXH */
		if(joy & TRG_UP && cursel > 0             ) cursel--;
		if(joy & TRG_DN && cursel < file_count - 1) cursel++;
		if(joy & TRG_LF) {
			cursel -= MAX_DISP;
			if(cursel < 0) cursel = 0;
		}
		if(joy & TRG_RI) {
			cursel += MAX_DISP;
			if(cursel > file_count - 1) cursel = file_count - 1;
		}
		if(cursel < *curtop                 ) *curtop = cursel                 ;
		if(cursel > *curtop + (MAX_DISP - 1)) *curtop = cursel - (MAX_DISP - 1);

		/* H */
		if(joy & TRG_A) {
			result = cursel;
			break;
		}

		/* t@CXg\B */
		memset(vbuff, 0, sizeof vbuff);
		fi = &file_list[*curtop];
		y = 8;
		for(i = 0; i < MAX_DISP + 1/*ɏ镪`*/; i++) {
			i_list = *curtop + i;
			if(i_list > file_count - 1) break;
			if(i_list == cursel) {
				render_rectangle_fill(&render, 0, y - 1, DISP_X, 6 + 1, 2);
				c = 0;
			} else {
				c = 2;
			}
			render_string(&render, 4 + 4 *  1, y, fi->filename, 0x82, c);
			render_printf(&render, 4 + 4 * 15, y, 0x82, c, "%8d bytes", fi->length);
			fi++;
			y += 6;
		}

		/* ^Cg\Biɂ͂ݏot@CXgɏ㏑j */
		render_rectangle_fill(&render, 0, 0, DISP_X, 6 + 1, 3);
		render_string(&render, 0, 1,
		//       0123456789012345678901234567890123
			"============= CHIP/8 =============",
			0x82, 0);
	}
	pcePadSetTrigMode(PP_MODE_SINGLE); /* I[gs[gOFF */

	return result;
}

/****************************************************************************
 *	run
 ****************************************************************************/

void
run(DRIVER* driver, const char* fname)
{
	static PCEWAVEINFO wi;
	static unsigned char wbuff[64];
	//
	int retval, i, snd;
	CHIP8* chip8 = &driver->chip8;
	CONFIG* config = &driver->config;

	/* TEhX^[gB({[ON/OFF܂) */
	memset(&wi, 0, sizeof(PCEWAVEINFO));
	wi.type = PW_TYPE_8BITPCM | PW_TYPE_CONT;
	wi.pData = wbuff;
	wi.len = sizeof wbuff / sizeof *wbuff;
	wi.next = &wi;
	for(i = 0; i < sizeof wbuff; i++) {
		wbuff[i] = i < sizeof wbuff / 2 ? 0x00 : 0xff;
	}
	pceWaveDataOut(0, &wi);
	pceWaveSetChAtt(0, 127); /* OFF */
	snd = 0;                 /* OFF */

RESET:
	/* CHIP-8RAZbgB */
	chip8_reset(chip8);

	/* vO[hB */
	retval = chip8_load(chip8, fname);
	if(retval != 0) DIE();

	/* RtBO\B */
	show_config(driver, -1);

	for(;;) {
		schedule();

		if(joy & TRG_START) { /* MENU */
			pceWaveSetChAtt(0, 127); snd = 0; /* MENU̓TEhOFF */
			if(do_config(driver) != 0) break;
			show_config(driver, -1); /*Kv!*/
			continue;
		} else if(joy & TRG_SELECT) { /* RESET */
			goto RESET;
		}

		/* L[͍XVB */
		update_key(driver);

		/* CPUsB */
		chip8_run(chip8, config->spd);

		/* G~[VI? */
		if(chip8->stat & CHIP8_EXIT) {
			render_printf_framed(&render, (DISP_X - (5 * 23 + 1)) / 2, (CHIP8_SCRHI_H - (10 + 1)) / 2, 0, 0x130,
			//	 012345678901234567890123
				"vOI܂");
			for(;;) {
				schedule();
				if(joy & (TRG_A | TRG_B | TRG_SELECT)) break;
			}
			break;
		}

		/* s? */
		if(chip8->stat & CHIP8_ILL) {
			render_printf_framed(&render, (DISP_X - (5 * 22 + 1)) / 2, (CHIP8_SCRHI_H - (10 + 2)) / 2, 0, 0x113,
			//	 0123456789012345678901
				"AhX %03x ɂ\n"
				"s߂s܂", (chip8->p - 2) & 0xfff);
			for(;;) {
				schedule();
				if(joy & (TRG_A | TRG_B | TRG_SELECT)) break;
			}
			break;
		}

		/* ^C}JEg_EB */
		chip8_tick(chip8, 1);

		/* TEhON/OFFB */
		if(chip8->st) {
			if(!snd) { /* OFF=>ON */
				pceWaveSetChAtt(0, 0);
				snd = 1;
			}
		} else {
			if(snd) { /* ON=>OFF */
				pceWaveSetChAtt(0, 127);
				snd = 0;
			}
		}

		/* ʍXVB */
		update_screen(driver);
	}

	/* TEhXgbvB */
	pceWaveAbort(0);
}

/****************************************************************************
 *	udpate_key
 ****************************************************************************/

void
update_key(DRIVER* driver)
{
	static const unsigned char dir[3][3] = {
		{ 8, 1, 2 },
		{ 7, 0, 3 },
		{ 6, 5, 4 },
	};

	CHIP8* chip8 = &driver->chip8;
	CONFIG* config = &driver->config;
	int x, y, v;

	/* ܂NAB */
	chip8->key = 0;

	/* ㉺E{^B */
	     if(joy & PAD_LF) x = 0;
	else if(joy & PAD_RI) x = 2;
	else                  x = 1;
	     if(joy & PAD_UP) y = 0;
	else if(joy & PAD_DN) y = 2;
	else                  y = 1;
	v = dir[y][x];
	if(v) chip8->key |= 1 << config->pad[v - 1];

	/* A/B{^B */
	if(joy & PAD_A) chip8->key |= 1 << config->trg[0];
	if(joy & PAD_B) chip8->key |= 1 << config->trg[1];
}

/****************************************************************************
 *	show_config
 ****************************************************************************/

#define CFG_SPD		 0
#define CFG_PAD1	 1
#define CFG_PAD2	 2
#define CFG_PAD3	 3
#define CFG_PAD4	 4
#define CFG_PAD5	 5
#define CFG_PAD6	 6
#define CFG_PAD7	 7
#define CFG_PAD8	 8
#define CFG_TRG1	 9
#define CFG_TRG2	10

/*
 *	0000000000111111111122222222223
 *	0123456789012345678901234567890
 *
 *	 [STA]:RESUME +CPU---+ +KEY---+
 *	 [SEL]:EXIT   |SPD999| |123   |
 *	 [A/B]:-/+    +------+ |4 6  A|
 *	                       |789 B |
 *	                       +------+
 */
void
show_config(DRIVER* driver, int sel)
{
#define X	0
#define Y	(CHIP8_SCRHI_H + 1)
#define W	(DISP_X - X)
#define H	(DISP_Y - Y)
#define C(i)	(i == sel ? ((now % SEC(0.5)) < SEC(0.3) ? 3 : 0) : 2)

	CONFIG* config = &driver->config;
	int x, y;

	render_rectangle_fill(&render, X, Y - 1, W, H + 1, 0);

	/* START,SELECT */
	x = X + 4 * 1;
	y = Y + 6 * 0;
	if(sel < 0) {
		render_string(&render, x + 4 * 0, y + 6 * 0, "[STA]:MENU"  , 0x82, 2);
		render_string(&render, x + 4 * 0, y + 6 * 1, "[SEL]:RESET" , 0x82, 2);
	} else {
		render_string(&render, x + 4 * 0, y + 6 * 0, "[STA]:RESUME", 0x82, 2);
		render_string(&render, x + 4 * 0, y + 6 * 1, "[SEL]:EXIT"  , 0x82, 2);
		render_string(&render, x + 4 * 0, y + 6 * 2, "[A/B]:-/+"   , 0x82, 2);
	}

	/* CPU */
	x = X + 4 * 14;
	y = Y + 6 *  0;
	render_rectangle(&render, x + 1, y + 2, 4 * 8 - 3, 6 * 3 - 5, 2);
	render_rectangle_fill(&render, x + 4 * 1 - 1, y + 6 * 0, 4 * 3 + 1, 6 - 1, 0);
	render_string        (&render, x + 4 * 1    , y + 6 * 0, "CPU", 0x82, 2);
	render_string        (&render, x + 4 * 1    , y + 6 * 1, "SPD", 0x82, 2);
	render_printf        (&render, x + 4 * 4    , y + 6 * 1, 0x82, C(CFG_SPD), "%3d", config->spd);

	/* KEY */
	x = X + 4 * 23;
	y = Y + 6 *  0;
	render_rectangle(&render, x + 1, y + 2, 4 * 8 - 3, 6 * 5 - 5, 2);
	render_rectangle_fill(&render, x + 4 * 1 - 1, y + 6 * 0    , 4 * 3 + 1, 6 - 1, 0);
	render_string        (&render, x + 4 * 1    , y + 6 * 0    , "KEY", 0x82, 2);
	render_point         (&render, x + 4 * 2 + 0, y + 6 * 2 + 1, 1);
	render_point         (&render, x + 4 * 2 + 1, y + 6 * 2 + 1, 2);
	render_point         (&render, x + 4 * 2 + 2, y + 6 * 2 + 1, 1);
	render_point         (&render, x + 4 * 2 + 0, y + 6 * 2 + 2, 2);
	render_point         (&render, x + 4 * 2 + 1, y + 6 * 2 + 2, 3);
	render_point         (&render, x + 4 * 2 + 2, y + 6 * 2 + 2, 2);
	render_point         (&render, x + 4 * 2 + 0, y + 6 * 2 + 3, 1);
	render_point         (&render, x + 4 * 2 + 1, y + 6 * 2 + 3, 2);
	render_point         (&render, x + 4 * 2 + 2, y + 6 * 2 + 3, 1);
	render_printf        (&render, x + 4 * 2    , y + 6 * 1    , 0x82, C(CFG_PAD1), "%X", config->pad[0]);
	render_printf        (&render, x + 4 * 3    , y + 6 * 1    , 0x82, C(CFG_PAD2), "%X", config->pad[1]);
	render_printf        (&render, x + 4 * 3    , y + 6 * 2    , 0x82, C(CFG_PAD3), "%X", config->pad[2]);
	render_printf        (&render, x + 4 * 3    , y + 6 * 3    , 0x82, C(CFG_PAD4), "%X", config->pad[3]);
	render_printf        (&render, x + 4 * 2    , y + 6 * 3    , 0x82, C(CFG_PAD5), "%X", config->pad[4]);
	render_printf        (&render, x + 4 * 1    , y + 6 * 3    , 0x82, C(CFG_PAD6), "%X", config->pad[5]);
	render_printf        (&render, x + 4 * 1    , y + 6 * 2    , 0x82, C(CFG_PAD7), "%X", config->pad[6]);
	render_printf        (&render, x + 4 * 1    , y + 6 * 1    , 0x82, C(CFG_PAD8), "%X", config->pad[7]);
	render_printf        (&render, x + 4 * 6    , y + 6 * 2    , 0x82, C(CFG_TRG1), "%X", config->trg[0]);
	render_printf        (&render, x + 4 * 5    , y + 6 * 3    , 0x82, C(CFG_TRG2), "%X", config->trg[1]);

#undef X
#undef Y
#undef W
#undef H
}

/****************************************************************************
 *	do_config
 ****************************************************************************/

int
do_config(DRIVER* driver)
{
	CONFIG* config = &driver->config;
	int result = 0;
	int sel = 0;

	pcePadSetTrigMode(PP_MODE_REPEAT); /* I[gs[gON */
	for(;;) {
		schedule();
		show_config(driver, sel);

		if(joy & TRG_START ) { result =  0; break; }
		if(joy & TRG_SELECT) { result = -1; break; }

		switch(sel) {
		case CFG_SPD:
			if(joy & TRG_RI) { sel = CFG_PAD8; break; }
			if(joy & TRG_UP) { config->spd += 50; if(config->spd > SPD_MAX) config->spd = SPD_MAX; } /* A{^ō */
			if(joy & TRG_DN) { config->spd -= 50; if(config->spd < SPD_MIN) config->spd = SPD_MIN; } /* A{^ō */
			if((joy & TRG_A) && (config->spd < SPD_MAX)) { config->spd++; break; }
			if((joy & TRG_B) && (config->spd > SPD_MIN)) { config->spd--; break; }
			break;
		case CFG_PAD1:
			if(joy & TRG_DN) { sel = CFG_PAD5; break; }
			if(joy & TRG_LF) { sel = CFG_PAD8; break; }
			if(joy & TRG_RI) { sel = CFG_PAD2; break; }
			if(joy & TRG_A) { config->pad[0] = (config->pad[0] + 1) & 0xf; }
			if(joy & TRG_B) { config->pad[0] = (config->pad[0] - 1) & 0xf; }
			break;
		case CFG_PAD2:
			if(joy & TRG_DN) { sel = CFG_PAD3; break; }
			if(joy & TRG_LF) { sel = CFG_PAD1; break; }
			if(joy & TRG_RI) { sel = CFG_TRG2; break; }
			if(joy & TRG_A) { config->pad[1] = (config->pad[1] + 1) & 0xf; }
			if(joy & TRG_B) { config->pad[1] = (config->pad[1] - 1) & 0xf; }
			break;
		case CFG_PAD3:
			if(joy & TRG_UP) { sel = CFG_PAD2; break; }
			if(joy & TRG_DN) { sel = CFG_PAD4; break; }
			if(joy & TRG_LF) { sel = CFG_PAD7; break; }
			if(joy & TRG_RI) { sel = CFG_TRG2; break; }
			if(joy & TRG_A) { config->pad[2] = (config->pad[2] + 1) & 0xf; }
			if(joy & TRG_B) { config->pad[2] = (config->pad[2] - 1) & 0xf; }
			break;
		case CFG_PAD4:
			if(joy & TRG_UP) { sel = CFG_PAD3; break; }
			if(joy & TRG_LF) { sel = CFG_PAD5; break; }
			if(joy & TRG_RI) { sel = CFG_TRG2; break; }
			if(joy & TRG_A) { config->pad[3] = (config->pad[3] + 1) & 0xf; }
			if(joy & TRG_B) { config->pad[3] = (config->pad[3] - 1) & 0xf; }
			break;
		case CFG_PAD5:
			if(joy & TRG_UP) { sel = CFG_PAD1; break; }
			if(joy & TRG_LF) { sel = CFG_PAD6; break; }
			if(joy & TRG_RI) { sel = CFG_PAD4; break; }
			if(joy & TRG_A) { config->pad[4] = (config->pad[4] + 1) & 0xf; }
			if(joy & TRG_B) { config->pad[4] = (config->pad[4] - 1) & 0xf; }
			break;
		case CFG_PAD6:
			if(joy & TRG_UP) { sel = CFG_PAD7; break; }
			if(joy & TRG_LF) { sel = CFG_SPD; break; }
			if(joy & TRG_RI) { sel = CFG_PAD5; break; }
			if(joy & TRG_A) { config->pad[5] = (config->pad[5] + 1) & 0xf; }
			if(joy & TRG_B) { config->pad[5] = (config->pad[5] - 1) & 0xf; }
			break;
		case CFG_PAD7:
			if(joy & TRG_UP) { sel = CFG_PAD8; break; }
			if(joy & TRG_DN) { sel = CFG_PAD6; break; }
			if(joy & TRG_LF) { sel = CFG_SPD; break; }
			if(joy & TRG_RI) { sel = CFG_PAD3; break; }
			if(joy & TRG_A) { config->pad[6] = (config->pad[6] + 1) & 0xf; }
			if(joy & TRG_B) { config->pad[6] = (config->pad[6] - 1) & 0xf; }
			break;
		case CFG_PAD8:
			if(joy & TRG_DN) { sel = CFG_PAD7; break; }
			if(joy & TRG_LF) { sel = CFG_SPD; break; }
			if(joy & TRG_RI) { sel = CFG_PAD1; break; }
			if(joy & TRG_A) { config->pad[7] = (config->pad[7] + 1) & 0xf; }
			if(joy & TRG_B) { config->pad[7] = (config->pad[7] - 1) & 0xf; }
			break;
		case CFG_TRG1:
			if(joy & TRG_DN) { sel = CFG_TRG2; break; }
			if(joy & TRG_LF) { sel = CFG_TRG2; break; }
			if(joy & TRG_A) { config->trg[0] = (config->trg[0] + 1) & 0xf; }
			if(joy & TRG_B) { config->trg[0] = (config->trg[0] - 1) & 0xf; }
			break;
		case CFG_TRG2:
			if(joy & TRG_UP) { sel = CFG_TRG1; break; }
			if(joy & TRG_LF) { sel = CFG_PAD4; break; }
			if(joy & TRG_RI) { sel = CFG_TRG1; break; }
			if(joy & TRG_A) { config->trg[1] = (config->trg[1] + 1) & 0xf; }
			if(joy & TRG_B) { config->trg[1] = (config->trg[1] - 1) & 0xf; }
			break;
		default:
			DIE();
		}
	}
	pcePadSetTrigMode(PP_MODE_SINGLE); /* I[gs[gOFF */

	return result;
}

/****************************************************************************
 *	load_config
 ****************************************************************************/

const CONFIG default_config = {
	10,
	{ 0x2,0x3,0x6,0x9,0x8,0x7,0x4,0x1 },
	{ 0xa,0xb },
};

int
load_config(CONFIG* config)
{
	int result = -1;
	FILE* fp = NULL;
	//
	int v;

	/* ܂li[܂B */
	*config = default_config;

	/* ݒt@CJ܂B */
	fp = fopen(CONFIG_FNAME, "r");
	if(!fp) goto L_EXIT;

	/* esǂ... */
	while(fgets(cfg_buf, sizeof cfg_buf, fp)) {
		if(sscanf(cfg_buf, "SPD=%d" , &v)) { if(v < SPD_MIN) v = SPD_MIN; if(v > SPD_MAX) v = SPD_MAX; config->spd = v; continue; }
		if(sscanf(cfg_buf, "PAD1=%X", &v)) { v &= 0xf; config->pad[0] = v; continue; }
		if(sscanf(cfg_buf, "PAD2=%X", &v)) { v &= 0xf; config->pad[1] = v; continue; }
		if(sscanf(cfg_buf, "PAD3=%X", &v)) { v &= 0xf; config->pad[2] = v; continue; }
		if(sscanf(cfg_buf, "PAD4=%X", &v)) { v &= 0xf; config->pad[3] = v; continue; }
		if(sscanf(cfg_buf, "PAD5=%X", &v)) { v &= 0xf; config->pad[4] = v; continue; }
		if(sscanf(cfg_buf, "PAD6=%X", &v)) { v &= 0xf; config->pad[5] = v; continue; }
		if(sscanf(cfg_buf, "PAD7=%X", &v)) { v &= 0xf; config->pad[6] = v; continue; }
		if(sscanf(cfg_buf, "PAD8=%X", &v)) { v &= 0xf; config->pad[7] = v; continue; }
		if(sscanf(cfg_buf, "TRG1=%X", &v)) { v &= 0xf; config->trg[0] = v; continue; }
		if(sscanf(cfg_buf, "TRG2=%X", &v)) { v &= 0xf; config->trg[1] = v; continue; }
		goto L_EXIT;
	}

	/* ǂݍݐ}[NB */
	result = 0;

L_EXIT:
	/* t@CJĂA܂B */
	if(fp) {
		fclose(fp);
		fp = NULL;
	}

	/* ǂݍݎsȂAlg܂B */
	if(result != 0) *config = default_config;

	return result;
}

int
save_config(const CONFIG* config)
{
	int retval, len;
	CONFIG old_cfg;
	FILEACC fa;

	/* ݂̐ݒt@Ce擾܂B */
	retval = load_config(&old_cfg);
	if(retval == 0) {
		/* ωȂ΁A܂B */
		if(memcmp(config, &old_cfg, sizeof(CONFIG)) == 0) return 0;
	}

	/* CFGt@Ce쐬܂B */
	len = sprintf(cfg_buf,
		"SPD=%d\n"	/* x */
		"PAD1=%X\n"	/*  */
		"PAD2=%X\n"	/* E */
		"PAD3=%X\n"	/* E */
		"PAD4=%X\n"	/* E */
		"PAD5=%X\n"	/*  */
		"PAD6=%X\n"	/*  */
		"PAD7=%X\n"	/*  */
		"PAD8=%X\n"	/*  */
		"TRG1=%X\n"	/* ` */
		"TRG2=%X\n",	/* a */
		config->spd,
		config->pad[0],
		config->pad[1],
		config->pad[2],
		config->pad[3],
		config->pad[4],
		config->pad[5],
		config->pad[6],
		config->pad[7],
		config->trg[0],
		config->trg[1]);

	/* ܂mɊ̐ݒt@C폜܂B() */
	pceFileDelete(CONFIG_FNAME); /* gt@ChG[͖ */

	/* ݒt@C쐬܂B */
	retval = pceFileCreate(CONFIG_FNAME, len);
	if(retval != 0) return -1;

	/* 쐬ݒt@CJ܂B */
	retval = pceFileOpen(&fa, CONFIG_FNAME, FOMD_WR);
	if(retval != 0) return -1;

	/* ݒt@C݂܂B */
	retval = pceFileWriteSct(&fa, cfg_buf, 0, len);
	if(retval != len) {
		pceFileClose(&fa);
		return -1;
	}

	/* ݒt@C܂B */
	pceFileClose(&fa);

	return 0;
}
